MPI_Init_thread(3)

NAME
MPI_Init_thread - Initialize the MPI execution environment

SYNOPSIS
int MPI_Init_thread(int *argc, char ***argv, int required, int *provided)

INPUT PARAMETERS
required
    - desired level of thread support (integer)

INPUT/OUTPUT PARAMETERS
argc
    - argc (None)
argv
    - argv (None)

OUTPUT PARAMETERS
provided
    - provided level of thread support (integer)

COMMAND LINE ARGUMENTS
MPI specifies no command-line arguments but does allow an MPI implementation to make use of them. See MPI_INIT for a description of the command line arguments supported by MPI_INIT and MPI_INIT_THREAD .

NOTES
The valid values for the level of thread support are:
MPI_THREAD_SINGLE
    - Only one thread will execute.
MPI_THREAD_FUNNELED
    - The process may be multi-threaded, but only the main thread will make MPI calls (all MPI calls are funneled to the main thread).
MPI_THREAD_SERIALIZED
    - The process may be multi-threaded, and multiple threads may make MPI calls, but only one at a time: MPI calls are not made concurrently from two distinct threads (all MPI calls are serialized).
MPI_THREAD_MULTIPLE
    - Multiple threads may call MPI, with no restrictions.

NOTES FOR FORTRAN
Note that the Fortran binding for this routine does not have the argc and argv arguments. ( MPI_INIT_THREAD(required, provided, ierror) )

ERRORS

All MPI routines (except MPI_Wtime and MPI_Wtick ) return an error value; C routines as the value of the function and Fortran routines in the last argument. Before the value is returned, the current MPI error handler is called. By default, this error handler aborts the MPI job. The error handler may be changed with MPI_Comm_set_errhandler (for communicators), MPI_File_set_errhandler (for files), and MPI_Win_set_errhandler (for RMA windows). The MPI-1 routine MPI_Errhandler_set may be used but its use is deprecated. The predefined error handler MPI_ERRORS_RETURN may be used to cause error values to be returned. Note that MPI does not guarantee that an MPI program can continue past an error; however, MPI implementations will attempt to continue whenever possible.

MPI_SUCCESS
    - No error; MPI routine completed successfully.
MPI_ERR_OTHER
    - Other error; use MPI_Error_string to get more information about this error code.

SEE ALSO
MPI_Init, MPI_Finalize